using System.Collections.ObjectModel;

using Windows.Foundation;

using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;

namespace TestProject;

/// <summary>
///  
/// </summary>
public sealed partial class MainPage : Page
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region  - MainPage()

    /// <summary>
    /// 
    /// </summary>
    public MainPage()
    {
        InitializeComponent();

        ObservableCollection<string> collection = new ObservableCollection<string>();

        for(int i = 1; i < 100; i++)
        {
            collection.Add($"׸ {i}");
        }

        this.itemsRepeater.ItemsSource = collection;

        this.scrollViewer.ViewChanged += scrollViewer_ViewChanged;
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region ũ    óϱ - scrollViewer_ViewChanged(sender, e)

    /// <summary>
    /// ũ    óϱ
    /// </summary>
    /// <param name="sender">̺Ʈ ߻</param>
    /// <param name="e">̺Ʈ </param>
    private void scrollViewer_ViewChanged(object sender, ScrollViewerViewChangedEventArgs e)
    {
        UIElement anchorElement = this.scrollViewer.CurrentAnchor;

        if(anchorElement == null)
        {
            this.messageTextBlock.Text = string.Empty;

            return;
        }

        string itemText = (anchorElement as TextBlock).Text;

        Rect anchorRectangle = anchorElement.TransformToVisual(this.scrollViewer).TransformBounds(new Rect(0, 0, anchorElement.ActualSize.X, anchorElement.ActualSize.Y));

        double anchorRelativeVerticalOffset = this.scrollViewer.VerticalOffset - anchorRectangle.Top;

        this.messageTextBlock.Text = $"Ŀ ׸ : {itemText} : Ŀ   : {anchorRelativeVerticalOffset:0.00} : ũ   : {this.scrollViewer.VerticalOffset:0.00}";
    }

    #endregion
}